DECLARE SUB MouseDriver (m0%, m1%, m2%, m3%)
DECLARE SUB TastoPremuto ()
DECLARE SUB Bordo (col1.cal%, col2.cal%)
DECLARE SUB BordoInf (aa%, bb%, ll%)
DECLARE SUB ScriviMsg (mes$, col1.cal%, col2.cal%)
DECLARE SUB Colora (r1%, r2%, c1%, c2%, cl%)
DECLARE SUB VisualizzaAiuto (testohelp$(), help$(), msg$(), j%, max.riga%, col.help%, col.barre%)
DECLARE SUB WDevice (fore%, back%)
DECLARE SUB WFile (iniz%, fore%, back%)
DECLARE SUB Delay (tempo!)

'*********** ING. LARINI CLAUDIO  via Canobbio, 21 - VERONA *****************
'*                        -- ERRE SYSTEM --                                 *
'*   nome: ERRE2LIB.BAS       versione: 02.00.00         pers: Erre System  *
'****************************************************************************

COMMON SHARED vidseg#
COMMON SHARED MouseChecked%, MouseType%, MousePresent%, lbutton%, rButton%, mButton%

CONST FALSE = 0, TRUE = -1

DEFINT A-Z
SUB Bordo (col1.cal%, col2.cal%)
SHARED vidseg#
     IF vidseg# = &HB800 THEN
         COLOR 8, 0
         aa = CSRLIN: bb = POS(0): LOCATE aa, bb
         FOR ij = 0 TO 1: PRINT CHR$(SCREEN(aa, bb + ij)); : NEXT
     END IF
     COLOR col1.cal, col2.cal
END SUB

SUB BordoInf (aa%, bb%, ll%)
SHARED vidseg#
   IF vidseg# = &HB800 THEN
      COLOR 8, 0: LOCATE aa, bb
      FOR ij = 0 TO ll: PRINT CHR$(SCREEN(aa, bb + ij)); : NEXT
   END IF
END SUB

SUB Colora (r1, r2, c1, c2, cl)
   FOR row = r1 TO r2: rr = 160 * row - 161
       FOR col2 = c1 TO c2: POKE 2 * col2 + rr, cl: NEXT
   NEXT
END SUB

SUB Delay (tempo!)
   t1! = TIMER
   DO WHILE TIMER - t1! < tempo!: LOOP
END SUB

SUB MouseBorder (MouseRow1, MouseCol1, MouseRow2, MouseCol2)
    CALL MouseDriver(7, 0, (MouseCol1 - 1) * 8, (MouseCol2 - 1) * 8)
    CALL MouseDriver(8, 0, (MouseRow1 - 1) * 8, (MouseRow2 - 1) * 8)
END SUB

SUB MouseDriver (m0, m1, m2, m3)
    DIM Inary%(0 TO 9), Outary%(0 TO 9)
    CONST AX = 0, BX = 1, CX = 2, DX = 3, BP = 4, SI = 5, DI = 6, FL = 7, DS = 8, ES = 9
    IF MouseChecked = FALSE THEN
        DEF SEG = 0
        MouseSegment& = 256& * PEEK(207) + PEEK(206)
        MouseOffset& = 256& * PEEK(205) + PEEK(204)
        DEF SEG = MouseSegment&
        IF (MouseSegment& = 0 AND MouseOffset& = 0) OR PEEK(MouseOffset&) = 207 THEN
            MousePresent = FALSE
            MouseChecked = TRUE
            DEF SEG
        END IF
    END IF
    IF MousePresent = FALSE AND MouseChecked = TRUE THEN EXIT SUB
    Inary%(AX) = m0
    Inary%(BX) = m1
    Inary%(CX) = m2
    Inary%(DX) = m3
    CALL INT86XOLD(&H33, Inary%(), Outary%())
    m0 = Outary%(AX)
    m1 = Outary%(BX)
    m2 = Outary%(CX)
    m3 = Outary%(DX)
    IF MouseChecked THEN EXIT SUB
    IF m0 AND NOT MouseChecked THEN
        MousePresent = TRUE
        DEF SEG
    END IF
    IF m1 AND 2 THEN MouseType = 2
    IF m1 AND 3 THEN MouseType = 3
    MouseChecked = TRUE
END SUB

SUB MouseHide
    CALL MouseDriver(2, 0, 0, 0)
END SUB

SUB MouseInit
    CALL MouseDriver(0, 0, 0, 0)
END SUB

SUB MousePoll (MouseRow, MouseCol, lbutton, rButton, mButton)
    CALL MouseDriver(3, MouseButton, MouseCol, MouseRow)
    MouseRow = MouseRow / 8 + 1
    MouseCol = MouseCol / 8 + 1
    lbutton = FALSE: IF MouseButton AND 1 THEN lbutton = TRUE
    rButton = FALSE: IF MouseButton AND 2 THEN rButton = TRUE
    mButton = FALSE: IF MouseButton AND 4 THEN mButton = TRUE
END SUB

SUB MouseSetP (MouseRow1, MouseCol1)
   CALL MouseDriver(4, 0, (MouseCol1 - 1) * 8, (MouseRow1 - 1) * 8)
END SUB

SUB MouseShow
    CALL MouseDriver(1, 0, 0, 0)
END SUB

SUB ScriviMsg (mes$, col1.cal%, col2.cal%)
SHARED vidseg#
   pos.msg = 40 - LEN(mes$) \ 2
   IF vidseg# = &HB000 THEN col1.cal = nero: col2.cal = bianco
   LOCATE 11, pos.msg: COLOR col1.cal, col2.cal: PRINT " "; STRING$(LEN(mes$), ""); " ";
   LOCATE 12, pos.msg: COLOR col1.cal, col2.cal: PRINT " "; mes$; " "; : CALL Bordo(col1.cal, col2.cal)
   LOCATE 13, pos.msg: COLOR col1.cal, col2.cal: PRINT " "; STRING$(LEN(mes$), ""); " "; : CALL Bordo(col1.cal, col2.cal)
   CALL BordoInf(CSRLIN + 1, pos.msg + 2, LEN(mes$) + 3)
   COLOR col1.cal, col2.cal
END SUB

SUB TastoPremuto
   DO WHILE INKEY$ = "": LOOP
END SUB

SUB VisualizzaAiuto (testohelp$(), help$(), msg$(), j, max.riga%, col.help, col.barre)

      ft80$ = "\" + SPACE$(78) + "\": ft25$ = "\" + SPACE$(23) + "\"
30500 posiz = j: ind1 = 0: k = 1: escape = 0
      OPEN "i", #1, "erre.hlp"
      DO WHILE NOT EOF(1) AND NOT escape
         LINE INPUT #1, a$
         IF LEFT$(a$, 1) = "#" THEN k = k + 1 ELSE IF k = posiz THEN ind1 = ind1 + 1: testohelp$(ind1) = a$
         IF k > posiz THEN escape = -1
      LOOP
      CLOSE #1
      BSAVE "help2.$$$", 0, 160 * max.riga%: cc = col.help: GOSUB 31900
      COLOR fore, back: CLS
      PRINT STRING$(26, ""); ""; : cc = col.barre: GOSUB 31900
      COLOR fore, back: PRINT USING ft25$; help$(j); : cc = col.help: GOSUB 31900: COLOR fore, back
      PRINT ""; STRING$(26, ""): top = 1: bottom = max.riga% - 2
      LOCATE max.riga%, 1: cc = col.barre: GOSUB 31900: PRINT USING ft80$; msg$(41); : cc = col.help: GOSUB 31900: COLOR fore, back
      pgg = max.riga% - 5
30650 FOR k = top TO bottom: LOCATE k - top + 2, 1: PRINT USING ft80$; testohelp$(k); : NEXT
30660 ch$ = INKEY$: IF ch$ = "" THEN 30660
      IF ch$ = CHR$(27) THEN BLOAD "help2.$$$": EXIT SUB
      IF ch$ = CHR$(0) + CHR$(80) THEN top = top + 1: bottom = bottom + 1: IF bottom > ind1 THEN bottom = ind1: top = top - 1
      IF ch$ = CHR$(0) + CHR$(72) THEN top = top - 1: bottom = bottom - 1: IF top < 1 THEN top = 1: bottom = bottom + 1
      IF ch$ = CHR$(0) + CHR$(81) THEN top = top + pgg: bottom = bottom + pgg: IF bottom > ind1 THEN bottom = ind1: top = bottom - pgg - 2: IF top < 1 THEN top = 1
      IF ch$ = CHR$(0) + CHR$(73) THEN top = top - pgg: bottom = bottom - pgg: IF top < 1 THEN top = 1: bottom = 1 + pgg + 2: IF bottom > ind1 THEN bottom = ind1
      GOTO 30650

31900 fore = (7 AND cc): back = (112 AND cc) / 16 'calcolo colori
      IF (cc AND 8) THEN fore = fore + 8
      COLOR fore, back: RETURN

END SUB

SUB WDevice (fore%, back%)
     LOCATE 10, 28: PRINT ""; STRING$(48, ""); ""
     LOCATE 11, 28: PRINT " Device di uscita [SCRN:] : "; SPACE$(20); ""; : CALL Bordo(fore, back)
     LOCATE 12, 28: PRINT ""; STRING$(48, ""); ""; : CALL Bordo(fore, back)
     CALL BordoInf(13, 30, 49): COLOR fore, back
END SUB

SUB WFile (iniz%, fore%, back%)
     LOCATE iniz% + 5, 2: PRINT ""; STRING$(72, ""); ""
     LOCATE iniz% + 6, 2: PRINT " Nome file: "; SPACE$(60); ""; : CALL Bordo(fore, back)
     LOCATE iniz% + 7, 2: PRINT ""; STRING$(72, ""); ""; : CALL Bordo(fore, back)
     CALL BordoInf(iniz% + 8, 4, 73): COLOR fore, back
END SUB

