!----------------------------------------------------------------------
! HANOI.R : risolve il gioco della torre di Hanoi usando un algoritmo 
! ricorsivo modificato.
!----------------------------------------------------------------------

PROGRAM HANOI

DIM PIOLI%[3]

!$INCLUDE="PC.LIB"

PROCEDURE PRINTMOVE
MOSSE%=MOSSE%+1
CASE I% OF
  1-> SOURCE$="Sinistra" END ->
  2-> SOURCE$="Centro" END ->
  3-> SOURCE$="Destra" END ->
END CASE
CASE J% OF
  1-> DEST$="Sinistra" END ->
  2-> DEST$="Centro" END ->
  3-> DEST$="Destra" END ->
END CASE
PIOLI%[I%]=PIOLI%[I%]-1
PIOLI%[J%]=PIOLI%[J%]+1
FOR INDICE%=1 TO 3
    LOCATE(23,15*INDICE%+10)
    PRINT(MID$(STRINGA$,(INDICE%-1)*10+1,10))
    FOR NUM%=1 TO MAXNUM%
        LOCATE(23-NUM%,15*INDICE%+10)
        IF NUM%<=PIOLI%[INDICE%] THEN
              PRINT("";)
           ELSE
              PRINT("      ";)
        END IF
    END FOR
END FOR
LOCATE(7,1)
PRINT("Muovo un disco da ";SOURCE$;" a ";DEST$;"   ";)
LOCATE(1,60)
COLOR(0,7)
PRINT("Mossa n";MOSSE%;)
COLOR(7,0)
END PROCEDURE

PROCEDURE MOVE
  IF NUMBER%<>0 THEN
     NUMBER%=NUMBER%-1
     J%=6-I%-J%
     MOVE
     J%=6-I%-J%
     PRINTMOVE
     I%=6-I%-J%
     MOVE
     I%=6-I%-J%
     NUMBER%=NUMBER%+1
  END IF
END PROCEDURE

BEGIN
  CLS
  MAXNUM%=12
  MOSSE%=0
  PRINT(TAB(25);" TORRE DI HANOI ")
  REPEAT
     LOCATE(3,1)
     PRINT("Numero di dischi";)
     INPUT(NUMBER%)
  UNTIL NUMBER%>1 AND NUMBER%<=MAXNUM%
  LOCATE(5,1)
  PRINT("Per muovere";NUMBER%;"dischi ci vogliono";2^NUMBER%-1;" mosse :")
  STRINGA$="Sinistra  Centro    Destra    "
  I%=1  ! numero del piolo sorgente
  J%=3  ! numero del piolo destinatario
  PIOLI%[I%]=NUMBER%
  MOVE
END PROGRAM
